%define up_version 2.3.0
%define up_release 135
%define spuinclude /usr/spu/include

Name:              libspe2
Version:           %{up_version}.%{up_release}
Release:           5%{?dist}
Summary:           SPE Runtime Management Library

Group:             System Environment/Libraries
License:           LGPLv2+
URL:               http://sourceforge.net/projects/libspe/
Source0:           http://downloads.sourceforge.net/sourceforge/libspe/%{name}-%{version}.tar.gz
Source1:           png-mtime.py
Patch:             libspe2-2.2.80-doxygen.patch
BuildRoot:         %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:     doxygen, graphviz, python

Requires(post):    /sbin/chkconfig
Requires(preun):   /sbin/service, /sbin/chkconfig
Requires(postun):  /sbin/service

#spu-binutils owns /usr/spu directory
Requires:          spu-binutils

ExclusiveArch:     ppc ppc64

%description
SPE Runtime Management Library for the Cell Broadband Engine Architecture.

%package devel
Summary:           SPE Runtime Management Library
Group:             Development/Libraries
Requires:          %{name} = %{version}-%{release}, pkgconfig

%description devel
Header and object files for SPE Runtime Management Library.

%ifarch ppc
%package -n elfspe2
Summary:           Helper for standalong SPE applications
Group:             System Environment/Libraries
Requires:          %{name} = %{version}-%{release}

%description -n elfspe2
This tool acts as a standalone loader for spe binaries.
%endif

%ifarch ppc64
%package adabinding-devel
Summary:           Ada package files porting libspe headers
Group:             Development/Libraries
Requires:          %{name} = %{version}-%{release}

%description adabinding-devel
Ada package files porting libspe headers Management Library.
%endif

%prep
%setup -q -n %{name}-%{up_version}
%patch -p1 -b .doxygen

%build
# It doesn't understand handling of %{?_smp_mflags}
make OPTFLAGS="%{optflags}" SYSROOT="" prefix=%{_prefix} libdir=%{_libdir}

%ifarch ppc
# It doesn't understand handling of %{?_smp_mflags}
make elfspe2-all OPTFLAGS="%{optflags}" SYSROOT="" prefix=%{_prefix} libdir=%{_libdir}
%endif

# Generate documentation via doxygen including the images
pushd doc
doxygen

# Solve multilib problems by changing the internal PNG timestamp to a reference timestamp;
# see http://fedoraproject.org/wiki/PackagingDrafts/MultilibTricks for further information.
#python %{SOURCE1} html/graph_legend.png ARCHITECTURE
popd

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT SYSROOT="" prefix=%{_prefix} libdir=%{_libdir} speinclude=%{spuinclude}
mv -f $RPM_BUILD_ROOT%{_prefix}/adainclude/* $RPM_BUILD_ROOT%{_includedir}

%ifarch ppc
make elfspe2-install DESTDIR=$RPM_BUILD_ROOT SYSROOT="" prefix=%{_prefix} libdir=%{_libdir} speinclude=%{spuinclude}
install -D -m 755 elfspe2.init $RPM_BUILD_ROOT%{_initrddir}/elfspe2

# Ada makes only sense on ppc64 arch
rm -f $RPM_BUILD_ROOT%{_includedir}/*.ads
%endif

# Remove unwanted files, static files and files for %doc
rm -f $RPM_BUILD_ROOT%{_includedir}/README-libspe2
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT{%{_libdir},%{_includedir}}/libspe.*

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%ifarch ppc
%post -n elfspe2
/sbin/chkconfig --add elfspe2
%{_bindir}/elfspe2-register

%preun -n elfspe2
if [ $1 -eq 0 ]; then
  /sbin/service elfspe2 stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del elfspe2
fi

%postun -n elfspe2
if [ $1 -ne 0 ]; then
  /sbin/service elfspe2 condrestart > /dev/null 2>&1 || :
fi
%endif

%files
%defattr(-,root,root)
%doc COPYING
%{_libdir}/%{name}.so.*

%files devel
%defattr(-,root,root)
%doc PATCH-SUBMITTING-RULES doc/ARCHITECTURE
%doc doc/html
%dir %{spuinclude}
%{_libdir}/%{name}.so
%{_includedir}/*2*.h
%{_includedir}/cbea_map.h
%{spuinclude}
%{_libdir}/pkgconfig/libspe2.pc

%ifarch ppc
%files -n elfspe2
%defattr(-,root,root)
%doc PATCH-SUBMITTING-RULES
%{_initrddir}/elfspe2
%{_bindir}/elfspe2-register
%{_bindir}/elfspe2-unregister
%{_bindir}/elfspe2
%endif

%ifarch ppc64
%files adabinding-devel
%defattr(-,root,root)
%doc ada/README
%{_includedir}/libspe2.ads
%{_includedir}/libspe2_types.ads
%{_includedir}/cbea_map.ads
%endif

%changelog
* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.3.0.135-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.3.0.135-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Dec  1 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.3.0.135-3
- spu-binutils now owns /usr/spu directory. (BZ 473666)
- libspe2-devel now owns /usr/spu/include directory. (BZ 473666)

* Mon Oct 20 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.3.0.135-2
- PNG files created by doxygen doesn't contain tIME anymore.
- elfspe2-register script called elfspe instead of elfspe2.

* Fri Oct 17 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.3.0.135-1
- Upgraded to latest upstream version.
- Upstream changed versioning convention. 

* Thu Sep 11 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.132-1
- Upgraded to latest upstream version

* Thu Jul 29 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.129-2
- Prepared for spu cross toolchain includes

* Thu Jul 29 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.129-1
- update to latest open source version to solve some bugs

* Thu Jul 24 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.95-5
- changed release name to include branch name

* Tue Jul 22 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.95-4
- Changed elfspe startup script to be enabled per default

* Wed Jul 16 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.95-3
- Changes according to package review comments.

* Mon Jun 02 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80.95-2
- Repaired rpm build errors

* Sat May 31 2008 Robert Scheck <robert@fedoraproject.org> 2.2.80.95-1
- Changes to (hopefully) match with Fedora Packaging Guidelines

* Fri Apr 11 2008 Jochen Roth <jroth@linux.vnet.ibm.com> 2.2.80-95
- adopted to suit Fedora's packaging guidelines

* Mon Aug 13 2007 Gerhard Stenzel <stenzel@de.ibm.com> 2.2.0-85
- fixes for rpmlint complaints

* Thu Nov 24 2005 Arnd Bergmann <arnd@arndb.de> 1.0.1-3
- initial spec file for fc5
